package tw.kfksvr;

import java.io.File;
import java.io.IOException;
import java.util.Properties;

import kafka.server.KafkaConfig;
import kafka.server.KafkaServerStartable;

import org.apache.commons.io.FileUtils;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.Producer;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.zookeeper.server.ServerConfig;
import org.apache.zookeeper.server.ZooKeeperServerMain;
import org.apache.zookeeper.server.quorum.QuorumPeerConfig;

public class KfkSvr {

	public static void main(String[] args) throws  Exception {
		
		//start local zookeeper
		System.out.println("starting local zookeeper...");
		QuorumPeerConfig quorumConfiguration = new QuorumPeerConfig();
		Properties zkProperties = new Properties(); 
		zkProperties.load(ClassLoader.getSystemResourceAsStream("zoo.cfg")); 
		FileUtils.cleanDirectory(new File(zkProperties.getProperty("dataDir")));
 		ZooKeeperServerMain zooKeeperServer = new ZooKeeperServerMain();
		final ServerConfig configuration = new ServerConfig(); 
		quorumConfiguration.parseProperties(zkProperties);
		configuration.readFrom(quorumConfiguration);  
		new Thread(new Runnable(){
			@Override
			public void run() {
				try {
					zooKeeperServer.runFromConfig(configuration);
				} catch (IOException e) { 
					e.printStackTrace();
				}
			}}).start();
		System.out.println("done");
		Thread.sleep(200);
		//start local kafka broker
	     Properties kafkaProperties = new Properties();;
	     kafkaProperties.load(ClassLoader.getSystemResourceAsStream("server.properties"));  
		FileUtils.cleanDirectory(new File( kafkaProperties.getProperty("log.dirs")));
	 	KafkaConfig kafkaConfig = new KafkaConfig(kafkaProperties);
		KafkaServerStartable kafka = new KafkaServerStartable(kafkaConfig);
		System.out.println("starting local kafka broker...");
		kafka.startup();
		System.out.println("done");
		
		

		Thread.sleep(200); 
		System.out.println("starting send kafka message...");
		Properties props = new Properties(); 
        props.put("bootstrap.servers", kafkaProperties.getProperty("bootstrap.servers")); 
        props.put("key.serializer",   "org.apache.kafka.common.serialization.StringSerializer");
        props.put("value.serializer",  "org.apache.kafka.common.serialization.StringSerializer"); 
        Producer<String, String> producer = new KafkaProducer<String, String>(props);
        for (int i=0;i<10000;i++) {   
               ProducerRecord<String, String> data = new ProducerRecord<String, String>("page_visits", "name"+i, "zs ls ww lhl");
               producer.send(data);
               Thread.sleep(500);
        } 
        producer.close();
		System.out.println("done");
	}

}
